# AbstractSelectorContainer

Extends \DataType Implements \SelectorContainer

This is the base class for selectors that can contain other selectors.

This class handles the common description attribute and provides a default implementation for reference handling and checking for circular references that is appropriate for types that can not be nested inside elements of the same type (i.e. patternset but not path)

author | Siad Ardroumli siad.ardroumli@gmail.com
package | phing.types.selectors

### Methods

## Convert the Selectors within this container to a string. This will just be a helper class for the subclasses that put their own name around the contents listed here.

    __toString() : string

### Response

`string`

comma separated list of Selectors contained in this one

## Add a new selector into this container.

    appendSelector(\FileSelector $selector) : void

throws |

### Arguments

#### $selector

`\FileSelector`

new selector to add

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference() : \BuildException

inherited

### Response

`\BuildException`

## add an "And" selector entry on the selector list

    createAnd() : \AndSelector

### Response

`\AndSelector`

## add a contains selector entry on the selector list

    createContains()

## add a contains selector entry on the selector list

    createContainsRegexp()

## add an extended selector entry on the selector list

    createCustom()

## add a selector date entry on the selector list

    createDate()

## add a depends selector entry on the selector list

    createDepend()

## add a depth selector entry on the selector list

    createDepth()

## add a selector different entry on the selector list

    createDifferent()

## add a selector filename entry on the selector list

    createFilename()

## add a majority selector entry on the selector list

    createMajority()

## add a "None" selector entry on the selector list

    createNone()

## add a "Not" selector entry on the selector list

    createNot()

## add an "Or" selector entry on the selector list

    createOr() : \OrSelector

### Response

`\OrSelector`

## add a present selector entry on the selector list

    createPresent()

## add a readable selector entry on the selector list

    createReadable()

## add a "Select" selector entry on the selector list

    createSelector() : \SelectSelector

### Response

`\SelectSelector`

## add a selector size entry on the selector list

    createSize()

## add a type selector entry on the selector list

    createType()

## add a writable selector entry on the selector list

    createWritable()

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference( &$stk, \Project $p) : void

inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

throws |

### Arguments

#### $stk

``

#### $p

`\Project`

## Performs the check for circular references and returns the referenced object.

    getCheckedRef( $requiredClass,  $dataTypeName) : mixed

inherited

throws |

### Arguments

#### $requiredClass

``

#### $dataTypeName

``

### Response

`mixed`

## Return the description for the current data type.

    getDescription()

inherited

retujrn | string

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Performs the check for circular references and returns the referenced FileSet.

    getRef(\Project $p) : \FileSet

throws |

### Arguments

#### $p

`\Project`

### Response

`\FileSet`

## Returns the set of selectors as an array.

    getSelectors(\Project $p) : array

throws |

### Arguments

#### $p

`\Project`

### Response

`array`

of selectors in this container

## Indicates whether there are any selectors here.

    hasSelectors() : boolean

### Response

`boolean`

Whether any selectors are in this container

## Has the refid attribute of this element been set?

    isReference() : boolean

inherited

### Response

`boolean`

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed() : \BuildException

inherited

### Response

`\BuildException`

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

inherited

{@inheritdoc}

## pushAndInvokeCircularReferenceCheck

    pushAndInvokeCircularReferenceCheck(\DataType $dt,  &$stk, \Project $p)

inherited static

### Arguments

#### $dt

`\DataType`

#### $stk

``

#### $p

`\Project`

## Gives the count of the number of selectors in this container

    selectorCount() : integer

throws |

### Response

`integer`

The number of selectors in this container

## Returns an array for accessing the set of selectors.

    selectorElements() : array

### Response

`array`

The array of selectors

## Sets a description of the current data type. It will be useful in commenting what we are doing.

    setDescription(string $desc) : void

inherited

### Arguments

#### $desc

`string`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

### Arguments

#### $r

`\Reference`

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes() : \BuildException

inherited

### Response

`\BuildException`

## <p> This validates each contained selector provided that the selector implements the validate interface.

    validate()

Ordinarily, this will validate all the elements of a selector container even if the isSelected() method of some elements is never called. This has two effects:

- Validation will often occur twice.
- Since it is not required that selectors derive from BaseSelector, there could be selectors in the container whose error conditions are not detected if their isSelected() call is never made.

### Properties

## selectorsList

    selectorsList :

### Type(s)

``

## The descriptin the user has set.

    description : string

inherited

var |

### Type(s)

`string`

## Value to the refid attribute.

    ref : \Reference

inherited

var |

### Type(s)

`\Reference`

## Are we sure we don't hold circular references?

    checked : boolean

inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

var |

### Type(s)

`boolean`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`